=== debian/changelog ===
wmalauncher (2018.1002-1mx17+1) mx; urgency=low

  * Initial packaging.

 -- Steven Pusser <stevep@mxlinux.org>  Thu, 09 Jan 2020 17:35:44 -0800
