=== debian/control ===
Source: wmalauncher
Section: x11
Priority: optional
Maintainer: Steven Pusser <stevep@mxlinux.org>
Build-Depends: cmake,
               debhelper (>= 11~),
               libimlib2-dev,
               librsvg2-dev,
               libxpm-dev
Standards-Version: 4.1.4
Homepage: https://sourceforge.net/projects/wmalauncher/

Package: wmalauncher
Architecture: any
Multi-Arch: foreign
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: easy to use app launcher for fluxbox, openbox, windowmaker, etc.
 Wmalauncher is an easy to use and highly configurable application launcher
 dockapp especially designed for fluxbox but which also works well under
 blackbox, openbox, and windowmaker.
 .
 Wmalauncher supports XPM, PNG, SVG icons, .desktop files, true-type 
 fonts (for tooltip text), allows to configure, among others, the background
 color, the border size, the brightness/contrast/gamma of icon, allows to
 draw a frame around the button, etc...
