## wmalauncher 2020.0124

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 # CMake script for wmalauncher 
 #
-# Copyright 2018 Sébastien Ballet. All rights reserved.
+# Copyright 2018-2020 Sébastien Ballet. All rights reserved.
 # 
 # Use of this source code is governed by the BSD 3-clause license
 # that can be found in the LICENSE file. 
@@ -135,8 +135,8 @@
 
 # Defines wmalauncher version number and copyright.
 #
-set(WMAL_VERSION "2018.1002")
-set(WMAL_COPYRIGHT "(c) 2018, Sébastien Ballet <slacker6896@gmail.com>")
+set(WMAL_VERSION "2020.0124")
+set(WMAL_COPYRIGHT "(c) 2018-2020, Sébastien Ballet <slacker6896@gmail.com>")
 
 # Sets the variable SYSRES_ROOTDIR to its default value, when required.
 #
