=== debian/changelog ===
wmalauncher (2020.0124-1mx25+2) mx; urgency=medium

  * trixie build
  
 -- Dolphin Oracle <dolphinoracle@gmail.com>  Sat, 28 Mar 2025 13:54:08 -0800

wmalauncher (2020.0124-1mx19+2) mx; urgency=medium

  * Add right-click-to-exit-in-conf-files-to-on.patch.

 -- Steven Pusser <stevep@mxlinux.org>  Sat, 25 Jan 2020 12:17:12 -0800

wmalauncher (2020.0124-1mx19+1) mx; urgency=medium

  * New upstream release: changes right-click-to-kill defaults.

 -- Steven Pusser <stevep@mxlinux.org>  Fri, 24 Jan 2020 15:23:23 -0800

wmalauncher (2020.0123~beta-1mx19+1) mx; urgency=medium

  * New upstream beta release.
    - Adds kill on right-click feature.

  * Update debian/copyright to 2020.

 -- Steven Pusser <stevep@mxlinux.org>  Thu, 23 Jan 2020 13:09:46 -0800

wmalauncher (2018.1002-1mx19+1) mx; urgency=low

  * Initial packaging.

 -- Steven Pusser <stevep@mxlinux.org>  Thu, 09 Jan 2020 17:35:44 -0800
