=== debian/control ===
--- 
+++ 
@@ -6,7 +6,8 @@
                debhelper (>= 11~),
                libimlib2-dev,
                librsvg2-dev,
-               libxpm-dev
+               libxpm-dev,
+               pkg-config
 Standards-Version: 4.1.4
 Homepage: https://sourceforge.net/projects/wmalauncher/
